#!/bin/sh

CACHE_CONF=/etc/cache.conf
CACHE_PATH=/cache
# 鰲װʷ
if [ -f ${CACHE_CONF} ]; then
	echo "iXCache has installed on this system, exit!"
	exit 0
fi

#freebsdϵͳ汾
OSVERSION=`sysctl -n kern.osreldate`
if [ $OSVERSION -le 900000 ]; then
	echo "The freebsd version should greater 9!"
	exit 0
else
	TERM='xterm'
	export TERM
fi

# Ƿаװ
dialog	--no-mouse  \
	--defaultno \
	--backtitle "WELCOME TO INSTALL IXCACHE" \
	--title     "WARNING"                    \
	--yesno     "This installation will write data on your disk\n\nDo you want to continue?\n\n" 0 0

# ˳װ
if [ $? -ne 0 ]; then
	exit
fi

# 
ALLDISKS=`sysctl -n kern.disks | sed -E 's/a?cd[0-9]//g'`
DISKCONT=`sysctl -n kern.disks | sed -E 's/a?cd[0-9]//g' | wc -w`

if [ "X$ALLDISKS" = "X" ]; then
	dialog	--no-mouse \
		--backtitle "WELCOME TO INSTALL IXCACHE" \
		--title     "WARNING"                    \
		--msgbox    "No disk detected in your system, the installation is aborted!\n\n" 0 0
	exit
fi

# 
ALLFACES=`ifconfig -l ether`
TOTALNIC=`ifconfig -l ether | wc -w`

if [ $TOTALNIC -lt 1 ]; then
	dialog	--no-mouse \
		--backtitle "WELCOME TO INSTALL IXCACHE" \
		--title     "WARNING"                    \
		--msgbox    "We need one network interfaces at least, the installation is aborted!\n\n" 0 0
	exit
fi

# 4Gڴ
MEMSIZE=`sysctl -n hw.physmem`
if [ $MEMSIZE -lt 4294967296 ]; then
	dialog	--no-mouse \
		--backtitle "WELCOME TO INSTALL IXCACHE" \
		--title     "WARNING"                    \
		--msgbox    "We need 4G memory at least, the installation is aborted!\n\n" 0 0
	exit
fi

# ϵͳ
TARGET=''
result=`df -h | grep -v -w 'Filesystem'`
while read fs size used avail cap mount;
do
	if [ "${mount}" = '/' ]; then
		err=`echo ${fs} | grep ^/dev/`
		[ "${err}" != "" ] && TARGET=`echo ${err} | cut -d'/' -f3 | cut -d'p' -f1`
	fi
done << EOF
	${result}
EOF

if [ "${TARGET}" = "" ]; then
	dialog	--no-mouse \
		--backtitle "WELCOME TO INSTALL IXCACHE" \
		--title     "WARNING"                    \
		--msgbox    "We don't found the freebsd system disk, the installation is aborted!\n\n" 0 0
	exit
fi

# ȷʹĿ
dialog	--no-mouse  \
	--defaultno \
	--backtitle "WELCOME TO INSTALL IXCACHE" \
	--title     "WARNING"                    \
	--yesno     "We detect the freebsd system installed on \"${TARGET}\"\n\nDo you want to install iXCache on this disk?\n\n" 0 0

# ֹװ
if [ $? -ne 0 ]; then
	dialog	--no-mouse  \
		--backtitle "WELCOME TO INSTALL IXCACHE" \
		--title     "ABORTED"                      \
		--msgbox    "Thank you, the installation is aborted!\n\nPlease remove the installation media.\n\n" 0 0
	exit
fi

# ݴб
avl_disk() {
	for item in $ALLDISKS; do
		[ "X$item" = "X$1" ] && continue

		# ȡͺ
		if [ $OSVERSION -ge 900000 ]; then
			vendor=`camcontrol devlist | grep "\<$item\>" | awk -F'>' '{print $1}' | sed 's/ /_/g'`
			size=`geom disk list -a $item | grep Mediasize | awk -F' ' '{print $3}'`

			# 9.0
			if [ "X$vendor" = "X" ]; then
				vendor="<Unknow_model>$size"
			else
				vendor="${vendor}>$size"
			fi
		else
			vendor=`atacontrol list | grep "\<$item\>" | awk -F'<' '{print $2}' | awk -F'>' '{print $1}' | sed 's/ /_/g'`

			# 9.0
			if [ "X$vendor" = "X" ]; then
				vendor="Unknow_model"
			fi
		fi

		# б
		DISKLIST="$DISKLIST $item $vendor off"
	done
}

# ѡݴ
DISKLIST=''
#DATADISK=''
#if [ ${DISKCONT} -ge 2 ]; then
#	avl_disk ${TARGET}
#	exec 3>&1
#
#	# ȡûѡ
#	DATADISK=`dialog --no-mouse \
#			 --backtitle "WELCOME TO INSTALL IXCACHE" \
#			 --title     "CHOOSE"                     \
#			 --checklist "Which disk(s) do you want to install as data disk(s)[Press the spacetab to select]?" 0 0 0 $DISKLIST 2>&1 1>&3`
#	exec 3>&-
#fi

# б
FACELIST=''
for nic in $ALLFACES; do
	device=`pciconf -lv | grep -A 4 "$nic@" | grep device | awk -F'=' '{print $2}' | sed 's/^ //;s/ /_/g'`

	# δ֪ͺ
	if [ "X$device" = "X" ]; then
		device="'Unknow_model'"
	fi

	# б
	FACELIST="$FACELIST $nic $device off"
done

# 
DOWNPORT=''
while :; do
	exec 3>&1

	# ȡûѡ
	DOWNPORT=`dialog --no-mouse \
			 --backtitle "WELCOME TO INSTALL IXCACHE" \
			 --title     "CHOOSE"                     \
			 --radiolist "Which interface do you want to use as download port[Press the spacetab to select]?" 0 0 0 $FACELIST 2>&1 1>&3`
	exec 3>&-

	# 
	if [ "X$DOWNPORT" != "X" ]; then
		break
	fi
done

# 
DATAPORT=''
while :; do
	exec 3>&1

	# ȡûѡ
	DATAPORT=`dialog --no-mouse \
			 --backtitle "WELCOME TO INSTALL IXCACHE" \
			 --title     "CHOOSE"                     \
			 --radiolist "Which interface do you want to use as data port[Press the spacetab to select]?" 0 0 0 $FACELIST 2>&1 1>&3`
	exec 3>&-

	# 
	if [ "X$DATAPORT" != "X" ]; then
		break
	fi
done

# ZFSڴС
OVERAGE=`expr $MEMSIZE / 2`
ARC_MAX="40M"

if   [ $OVERAGE -gt 4000000000 ]; then
	ARC_MAX=`expr $MEMSIZE / 1024 / 1024 - 4096`
	ARC_MAX="${ARC_MAX}M"
elif [ $OVERAGE -gt 2000000000 ]; then
	ARC_MAX=`expr $MEMSIZE / 1024 / 1024 - 2048`
	ARC_MAX="${ARC_MAX}M"
elif [ $OVERAGE -gt 1000000000 -a $OVERAGE -lt 2000000000 ]; then
	ARC_MAX="1000M"
elif [ $OVERAGE -gt 500000000  -a $OVERAGE -lt 1000000000 ]; then
	ARC_MAX="500M"
elif [ $OVERAGE -gt 256000000  -a $OVERAGE -lt 500000000  ]; then
	ARC_MAX="200M"
fi

# װϵͳ

# cacheĿ¼
mkdir -p ${CACHE_PATH}

#ƵǰĿ¼µipfwԼipfw.koӦĿ¼
cp -f ./bin/ipfw /sbin/
cp -f ./kernel/ipfw.ko /boot/kernel/

#ưװеĿ¼cacheĿ¼
ls -l ./ | grep ^d | awk '{print $9}' | while read dirname;
do
	cp -Rf ${dirname} ${CACHE_PATH}
done


sync
sync

# û
echo "UPDATE_INTERNAL=60"   > ${CACHE_CONF}
echo "IXCACHEPATH=/cache"  >> ${CACHE_CONF}
echo "DATA_ROOT=/data"     >> ${CACHE_CONF}
echo "DATA_PORT=$DATAPORT" >> ${CACHE_CONF}

# ZFS
LOADER_CONF=/boot/loader.conf
echo "autoboot_delay=\"2\""         >> ${LOADER_CONF}
echo "beastie_disable=\"YES\""      >> ${LOADER_CONF}
echo "mrsas_enable=\"YES\""         >> ${LOADER_CONF}
echo "hw.mfi.mrsas_enable=\"1\""    >> ${LOADER_CONF}
echo "vfs.zfs.arc_max=\"$ARC_MAX\"" >> ${LOADER_CONF}

# ʼZFS
mkdir -p /data/
echo "DATA_DISKS=\"\""   >> ${CACHE_CONF}
#POOLNAME=''
#if [ "X$DATADISK" != "X" ]; then
#	dialog	--no-mouse \
#		--backtitle "WELCOME TO INSTALL IXCACHE" \
#		--title     "INFO"                    \
#		--msgbox    "Create zpool, this operation would take a long time, please wait patiently!\n\n" 0 0
#
#	POOLNAME=pool
#	err=`zpool create -f -o failmode=continue -O checksum=on -O compression=lz4 -O atime=off -m /data/${POOLNAME} ${POOLNAME} ${DATADISK}`
#	[ "${err}" != "" ] && echo ${err}
#fi
#echo "DATA_DISKS=\"${POOLNAME}\""   >> ${CACHE_CONF}

# 
RC_LOCAL=/etc/rc.local
RC_CONF=/etc/rc.conf
echo "cron_dst=\"NO\"" >> ${RC_CONF}
echo "cron_enable=\"NO\"" >> ${RC_CONF}
echo "crashinfo_enable=\"NO\"" >> ${RC_CONF}
echo "check_quotas=\"NO\"" >>  ${RC_CONF}
echo "hostname=\"ixcache\"" >> ${RC_CONF}
echo "ip6addrctl_enable=\"NO\"" >> ${RC_CONF}
echo "mixer_enable=\"NO\"" >> ${RC_CONF}
echo "newsyslog_enable=\"NO\"" >> ${RC_CONF}
echo "sendmail_enable=\"NO\"" >> ${RC_CONF}
echo "sendmail_submit_enable=\"NO\"" >> ${RC_CONF}
echo "sendmail_outbound_enable=\"NO\"" >> ${RC_CONF}
echo "sendmail_msp_queue_enable=\"NO\"" >> ${RC_CONF}
echo "syslogd_enable=\"NO\"" >> ${RC_CONF}
echo "update_motd=\"NO\"" >> ${RC_CONF}
echo "zfs_enable=\"YES\"" >> ${RC_CONF}
echo "sshd_enable=\"YES\"" >> ${RC_CONF}

echo "set prompt = \"\`/bin/hostname -s\` (\`/usr/bin/uname -r\`) # \"" >> /root/.cshrc
echo "/cache/bin/zpool_verify" >> ${RC_LOCAL}
echo "/cache/bin/netcfg"       >> ${RC_LOCAL}
echo "/cache/bin/ixctrl start" >> ${RC_LOCAL}

# 
if [ "X$DOWNPORT" != "X" ]; then
	exec 3>&1
	MANAGE=`dialog	--no-mouse \
			--backtitle "WELCOME TO INSTALL IXCACHE" \
			--title     "DOWNLOAD PORT"              \
			--form      "Download port ($DOWNPORT) configuration as follows:" 0 0 0 \
			"IP address:"      1 0 "192.168.0.100" 1 20 16 0 \
			"Subnet mask:"     2 0 "255.255.255.0" 2 20 16 0 \
			"Default gateway:" 3 0 "192.168.0.1"   3 20 16 0 \
			"Primary DNS:"     4 0 "8.8.8.8"       4 20 16 0 \
			"Secondary DNS:"   5 0 "8.8.4.4"       5 20 16 0 2>&1 1>&3`
	exec 3>&-

	# ȡ
	if [ "X$MANAGE" != "X" ]; then
		ADMINADDR=`echo $MANAGE | awk '{print $1}'`
		MANAGADDR=`echo $MANAGE | awk '{print $1}'`
		ADMINMASK=`echo $MANAGE | awk '{print $2}'`
		ADMINGATE=`echo $MANAGE | awk '{print $3}'`
		MAINDNSIP=`echo $MANAGE | awk '{print $4}'`
		BACKDNSIP=`echo $MANAGE | awk '{print $5}'`

		echo "nameserver $MAINDNSIP"  > /etc/resolv.conf
		echo "nameserver $BACKDNSIP" >> /etc/resolv.conf

		if [ -e $IXCACHE ]; then
			echo "DOWNLOAD_PORT=$DOWNPORT"     > ${CACHE_PATH}/etc/ifdownload.conf
			echo "IFDOWNLOAD_IP=$ADMINADDR"   >> ${CACHE_PATH}/etc/ifdownload.conf
			echo "IFDOWNLOAD_MASK=$ADMINMASK" >> ${CACHE_PATH}/etc/ifdownload.conf
			echo "GATEWAY=$ADMINGATE"         >> ${CACHE_PATH}/etc/ifdownload.conf
		fi
	fi
fi

# 
if [ "X$DATAPORT" != "X" ]; then
	exec 3>&1
	MANAGE=`dialog	--no-mouse \
			--backtitle "WELCOME TO INSTALL IXCACHE" \
			--title     "DATA PORT"                  \
			--form      "Data port ($DATAPORT) configuration as follows:" 0 0 0 \
			"IP address:"  1 0 "192.168.1.100" 1 20 16 0 \
			"Subnet mask:" 2 0 "255.255.255.0" 2 20 16 0 2>&1 1>&3`
	exec 3>&-

	# ȡ
	if [ "X$MANAGE" != "X" ]; then
		ADMINADDR=`echo $MANAGE | awk '{print $1}'`
		ADMINMASK=`echo $MANAGE | awk '{print $2}'`

		if [ -e $IXCACHE ]; then
			echo "IFDATA_IP=$ADMINADDR"    > ${CACHE_PATH}/etc/ifdata.conf
			echo "IFDATA_MASK=$ADMINMASK" >> ${CACHE_PATH}/etc/ifdata.conf
		fi
	fi
fi

# ͬ
sync
sync
sleep 1

# ӡɹϢ
dialog	--no-mouse  \
	--backtitle "WELCOME TO INSTALL IXCACHE" \
	--title     "CONGRATULATIONS"            \
	--yes-label "Reboot"                     \
	--no-label  "Exit"                       \
	--yesno     "The system has been successfully installed, please remove the installation media and reboot the system.\n\nThen you can use the URL \"https://$MANAGADDR\" to manage it and configure iXCache follow the wizard in web\n\n" 0 0

# Ŀϵͳ
if [ $? -eq 0 ]; then
	sync && reboot
fi
